package com.qmth.eds.common.entity;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import com.qmth.eds.common.enums.ExamAssignStatusEnum;
import com.qmth.eds.common.enums.FormulaEnum;
import com.qmth.eds.core.base.BaseEntity;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;

/**
 * 赋分系数表
 */
@ApiModel(value = "ExamAssign对象", description = "赋分系数表")
public class ExamAssign extends BaseEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "学校id")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long schoolId;

    @ApiModelProperty(value = "学期id")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long semesterId;

    @ApiModelProperty(value = "考试类型id")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long examTypeId;

    @ApiModelProperty(value = "课程代码")
    private String courseCode;

    @ApiModelProperty(value = "课程名称")
    private String courseName;

    @ApiModelProperty(value = "开课学院")
    private String openCollege;

    @ApiModelProperty(value = "公式类型")
    private FormulaEnum formula;

    @ApiModelProperty(value = "系数json")
    private String coefficient;

    @ApiModelProperty(value = "状态")
    private ExamAssignStatusEnum status;

    public Long getSchoolId() {
        return schoolId;
    }

    public void setSchoolId(Long schoolId) {
        this.schoolId = schoolId;
    }

    public Long getSemesterId() {
        return semesterId;
    }

    public void setSemesterId(Long semesterId) {
        this.semesterId = semesterId;
    }

    public Long getExamTypeId() {
        return examTypeId;
    }

    public void setExamTypeId(Long examTypeId) {
        this.examTypeId = examTypeId;
    }

    public String getCourseCode() {
        return courseCode;
    }

    public void setCourseCode(String courseCode) {
        this.courseCode = courseCode;
    }

    public String getCourseName() {
        return courseName;
    }

    public void setCourseName(String courseName) {
        this.courseName = courseName;
    }

    public String getOpenCollege() {
        return openCollege;
    }

    public void setOpenCollege(String openCollege) {
        this.openCollege = openCollege;
    }

    public FormulaEnum getFormula() {
        return formula;
    }

    public void setFormula(FormulaEnum formula) {
        this.formula = formula;
    }

    public String getCoefficient() {
        return coefficient;
    }

    public void setCoefficient(String coefficient) {
        this.coefficient = coefficient;
    }

    public ExamAssignStatusEnum getStatus() {
        return status;
    }

    public void setStatus(ExamAssignStatusEnum status) {
        this.status = status;
    }
}
