package com.qmth.eds.common.enums;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * 赋分状态
 */
public enum ExamAssignStatusEnum {

    INIT("未计算"),

    RUNNING("计算中"),

    FINISH("计算完成");

    private String desc;

    private ExamAssignStatusEnum(String desc) {
        this.desc = desc;
    }

    public String getDesc() {
        return desc;
    }

    /**
     * 状态转换 toName
     *
     * @param title
     * @return
     */
    public static String convertToName(String title) {
        for (ExamAssignStatusEnum e : ExamAssignStatusEnum.values()) {
            if (Objects.equals(title, e.getDesc())) {
                return e.name();
            }
        }
        return null;
    }

    /**
     * @return
     */
    public static List<EnumResult> listTypes() {
        List<EnumResult> list = new ArrayList<EnumResult>();
        for (ExamAssignStatusEnum value : ExamAssignStatusEnum.values()) {
            EnumResult result = new EnumResult();
            result.setName(value.name());
            result.setOrdinal(value.ordinal());
            result.setCode(null);
            result.setDesc(value.getDesc());
            list.add(result);
        }
        return list;
    }

}
