package com.qmth.eds.service;

import com.qmth.eds.bean.auth.AuthBean;
import com.qmth.eds.bean.result.MenuResult;
import com.qmth.eds.common.entity.SysRolePrivilege;
import com.qmth.eds.common.entity.SysUserRole;
import com.qmth.eds.common.enums.PrivilegePropertyEnum;

import java.util.List;
import java.util.Set;

/**
 * @Description: 公共服务service
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2021/3/26
 */
public interface CommonService {

    /**
     * 获取用户菜单
     *
     * @param userId
     * @return
     */
     MenuResult getUserMenu(Long userId);

    /**
     * 获取用户角色
     *
     * @param userId
     * @return
     */
     List<SysUserRole> getUserRolePrivilege(Long userId);

    /**
     * 获取角色权限
     *
     * @param roleId
     * @return
     */
     List<SysRolePrivilege> getRolePrivilege(Long roleId);

    /**
     * 获取用户权限
     *
     * @param userId
     * @return
     */
     AuthBean getUserAuth(Long userId);

    /**
     * 获取鉴权url
     *
     * @param privilegePropertyEnum
     * @return
     */
     Set<String> getPrivilegeUrl(PrivilegePropertyEnum privilegePropertyEnum);

    /**
     * 获取鉴权url
     *
     * @param privilegePropertyEnum
     * @param schoolId
     * @return
     */
     Set<String> getPrivilegeUrl(PrivilegePropertyEnum privilegePropertyEnum, Long schoolId);

    /**
     * 查询系统参数值
     * @param schoolId 学校ID
     * @param code key
     * @return
     */
    String getSysSettingValue(Long schoolId, String code);
}
